/*
 * QuoteViewer.java
 *
 * Created on 10 de agosto de 2004, 18:07
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Quote;
import com.fenalco.entities.Store;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.QuoteViewSupplier;

/**
 * Este servlet se encarga de generar la información necesaria para que un
 * proveedor pueda ver el detalle de una cotización y una vez allí pueda
 * responderla asignando los precios o rechazarla.
 * 
 * @author andres
 */
public class QuoteViewer extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración
	 * @throws ServletException
	 *             Excepción de falla en la operación de inicialización.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método construye un objeto del tipo <CODE>Quote</CODE> y un <CODE>
	 * Hashtable</CODE> de objetos tipo <CODE>QuoteProduct</CODE>.
	 * 
	 * Con esta información se construye la vista del proveedor en
	 * cotizacion.jsp
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				url = "/proveedor/cotizacion.jsp";
				Quote quote = new Quote(new Integer(request.getParameter("key"))
						.intValue());
				QuoteViewSupplier view = new QuoteViewSupplier(quote);
	
				if( view == null )
				{
					//Error al cargar la informacion de la cotizacion
					message = MessageBuilder.buildMessage(6);
				}
				else
				{
					//Todo OK
					//La carga de la cotizacion fue exitosa
					//message = MessageBuilder.buildMessage(3);
					message = "";
					request.setAttribute("quote", quote);
					String shopKeeperName = Store
							.getCompanyName(quote.getStoreId());
					request.setAttribute("shopKeeperName", shopKeeperName);
					request.setAttribute("view", view);
				}
			}
	
			if( request.getAttribute("message") != null )
			{
				message = (String) request.getAttribute("message");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }
		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo <CODE>PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una descripción general del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}